<?php

namespace Drupal\string_plural_form;

/**
 * Base Class for StringPluralForm Plugin implementation.
 */
abstract class StringPluralFormBase implements StringPluralFormPluginInterface {

  /**
   * {@inheritdoc}
   */
  public function generateLocalePluralIndex(?int $max = 199): array {
    $formula = [];
    $max_plural_form_index = $this->getGettextNplurals() - 1;
    $formula['default'] = $max_plural_form_index;
    for ($count = 0; $count <= $max; $count++) {
      if ($this->getIndex($count) != $max_plural_form_index) {
        $formula[$count] = $this->getIndex($count);
      }
    }
    return $formula;
  }

}
