<?php

namespace Drupal\Tests\string_plural_form\Unit\StringPluralForm;

use Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSlavicType1;

use Drupal\Tests\UnitTestCase;

/**
 * @coversDefaultClass \Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSlavicType1
 * @group StringPluralFormPlugins
 */
class ThreeFormsSlavicType1Test extends UnitTestCase {

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSlavicType1::getGettextNplurals()
   */
  public function testGetGettextNplurals() {
    $plugin = new ThreeFormsSlavicType1();
    $this->assertEquals(3, $plugin->getGettextNplurals());
  }

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSlavicType1::getGettextNplurals()
   */
  public function testGetGettextPlural() {
    $plugin = new ThreeFormsSlavicType1();
    $this->assertEquals("n%10==1 && n%100!=11 ? 0 : n%10>=2 && n%10<=4 && (n%100<10 || n%100>=20) ? 1 : 2", $plugin->getGettextPlural());
  }

  /**
   * Tests \Drupal\string_plural_form\Plugin\StringPluralForm\ThreeFormsSlavicType1::getIndex()
   */
  public function testGetIndex() {
    $plugin = new ThreeFormsSlavicType1();
    $expected_forms = [
      0 => [
        1, 21, 31, 41, 51, 61, 71, 81, 91,
        101, 121, 131, 141, 151, 161, 171, 181, 191,
      ],
      1 => [
        2, 3, 4,
        22, 23, 24,
        32, 33, 34,
        42, 43, 44,
        52, 53, 54,
        62, 63, 64,
        72, 73, 74,
        82, 83, 84,
        92, 93, 94,
        102, 103, 104,
        122, 123, 124,
        132, 133, 134,
        142, 143, 144,
        152, 153, 154,
        162, 163, 164,
        172, 173, 174,
        182, 183, 184,
        192, 193, 194,
      ],
      2 => [
        0, 5, 6, 7, 8, 9,
        10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
        20, 25, 26, 27, 28, 29,
        30, 35, 36, 37, 38, 39,
        40, 45, 46, 47, 48, 49,
        50, 55, 56, 57, 58, 59,
        60, 65, 66, 67, 68, 69,
        70, 75, 76, 77, 78, 79,
        80, 85, 86, 87, 88, 89,
        90, 95, 96, 97, 98, 99,
        100, 105, 106, 107, 108, 109,
        110, 111, 112, 113, 114, 115, 116, 117, 118, 119,
        120, 125, 126, 127, 128, 129,
        130, 135, 136, 137, 138, 139,
        140, 145, 146, 147, 148, 149,
        150, 155, 156, 157, 158, 159,
        160, 165, 166, 167, 168, 169,
        170, 175, 176, 177, 178, 179,
        180, 185, 186, 187, 188, 189,
        190, 195, 196, 197, 198, 199,
      ],
    ];

    foreach ($expected_forms as $index => $numbers) {
      foreach ($numbers as $n) {
        $this->assertEquals($index, $plugin->getIndex($n));
      }
    }
  }

}
